/* ident.h of iplog v1.1 -- eric@ojnk.nu */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <signal.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>


#define TCP_LISTEN		0x0A

#define TCP_DATA		"/proc/net/tcp"
#define IDENTD_FORMAT	"%*d , %*d : %*s : %*s : %63s"
#define LPORT_FORMAT	"%*d: %*X:%x %*X:%*x %x %*X:%*X %*x:%*X %*x %*d %*d %*d"
#define AUTH_PORT		113

u_char *get_identd_data(int r_port, int l_port, u_long r_addr, u_long l_addr) {
	fd_set fd_read;
	int s, on = 1;
	struct linger lin;
	struct timeval tv;
	struct sockaddr_in sin;
	char *buf;
	static char user[64];

	if ((buf = (char *)calloc(512, sizeof(char))) == NULL)
		return user;

	if ((s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) != INADDR_NONE) {
		lin.l_onoff = 0;
		lin.l_linger = 0;
		(void)setsockopt(s, SOL_SOCKET, SO_LINGER, (void *)&lin, sizeof(lin));
		(void)setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (void *)&on, sizeof(on));
		
		memset((char *)&sin, 0, sizeof(sin));
		sin.sin_family = AF_INET;
		sin.sin_addr.s_addr = l_addr;
		sin.sin_port = INADDR_ANY;

		if (bind(s, (struct sockaddr *)&sin, sizeof(sin)) != INADDR_NONE) {
			memset ((char *)&sin, 0, sizeof(sin));
			sin.sin_family = AF_INET;
			sin.sin_port = htons(AUTH_PORT);
			sin.sin_addr.s_addr = r_addr;

			if (connect(s,(struct sockaddr *)&sin,sizeof(sin)) != INADDR_NONE) {
				sprintf(buf, "%d , %d\r\n", r_port, l_port);
				send(s, buf, strlen(buf), 0);
				memset(buf, 0, sizeof(buf));

				tv.tv_sec = 10; /* that's probably too much! */
				tv.tv_usec = 0;
				FD_ZERO (&fd_read);
				FD_SET (s, &fd_read);

				if (select(s+1, &fd_read, NULL, NULL, &tv) > 0) {
					if (recv(s, buf, 512, 0) > 0) {
						sscanf(buf,	IDENTD_FORMAT, user);
					}
				}
				(void)close(s);
			}
		}
	}
	if (buf)
		free(buf);

	return (user);
}


/* Check if a local port "port" is listening--if the connection was refused,
   identd on the remote host has closed the connection and thus has no data
   on the connection, which makes attempting to get the ident reply stupid. */

int l_port(u_short port) {
	FILE *fp;
	int l_port, mode;
	char buf[BUFSIZ];

	if ((fp = fopen(TCP_DATA, "r")) < 0)
		return (-1);

	while (fgets(buf, sizeof(buf) - 1, fp) != NULL)
		if ((sscanf(buf, LPORT_FORMAT, &l_port, &mode) == 2) &&								(l_port == port) && (mode == TCP_LISTEN))
				break;

	(void)fclose(fp);

	if ((l_port == port) && (mode == TCP_LISTEN))
		return (1);

	return (0);
}
