/* iplog.h of iplog v1.1 -- eric@ojnk.nu */
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <stdio.h>
#include <pwd.h>
#include <grp.h>
#include <fcntl.h>
#include <errno.h>
extern int errno;

#include "config.h"

#ifndef DROP_USER
#	define DROP_USER "nobody"
#endif

#ifndef DROP_GROUP
#	define DROP_GROUP "nogroup"
#endif

#ifndef LOGGING_SEVERITY
#	define LOGGING_SEVERITY	LOG_PID
#endif

#ifndef LOGGING_FACILITY
#	define LOGGING_FACILITY LOG_DAEMON
#endif

#define LEVEL LOGGING_FACILITY

void fork_to_background() {
    switch (fork()) {
        case -1:
            _exit(0);
        case 0:
            break;
        default:
			_exit(0);
    }

	setsid();
    chdir("/");
    umask(022);

    (void)close(0); /* stdin */
    (void)close(1); /* stdout */
    (void)close(2); /* stderr */

	return;
}

void drop_privileges(void) {
	struct passwd *pw;

	{
		register int uid, gid;
		uid = (pw = getpwnam(DROP_USER))->pw_uid;
		gid = getgrnam(DROP_GROUP)->gr_gid;

		errno = 0;

		if (setregid(gid, gid) < 0)
			perror("setregid");

		if (initgroups(pw->pw_name, gid) < 0)
			perror("initgroups");

		if (setreuid(uid, uid) < 0)
			perror("setreuid");
		
		if (errno)
			exit(-1);
	}
	
	return;
}
